<id>
sonsivri:recyclebin
</id>

<version>
1.1
</version>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
			'recycle_board' => (int) $_POST['recycle_board'],
</search for>

<add after>
			'recycle_auto' => (!empty($_POST['recycle_auto']) && (int) $_POST['recycle_amount'] > 0) ? '1' : '0',
			'recycle_amount' => (int) $_POST['recycle_amount'],
</add after>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
		'last_post' => 't.ID_LAST_MSG'
</search for>

<replace>
		'last_post' => (!empty($modSettings['recycle_enable']) && ($modSettings['recycle_board'] == $board)) ? 't.recycledTime' : 't.ID_LAST_MSG'
</replace>

<search for>
		$_REQUEST['sort'] = 'ID_LAST_MSG';
</search for>

<replace>
		$_REQUEST['sort'] = (!empty($modSettings['recycle_enable']) && ($modSettings['recycle_board'] == $board)) ? 'recycledTime' : 'ID_LAST_MSG';
</replace>

<search for>
				t.ID_LAST_MSG, ml.posterTime AS lastPosterTime, ml.ID_MSG_MODIFIED,
</search for>

<replace>
				t.ID_LAST_MSG, t.recycledTime, ml.posterTime AS lastPosterTime, ml.ID_MSG_MODIFIED,
</replace>

<search for>
					'time' => timeformat($row['lastPosterTime']),
</search for>

<replace>
					'time' => (!empty($modSettings['recycle_enable']) && ($modSettings['recycle_board'] == $board)) ? timeformat($row['recycledTime']) : timeformat($row['lastPosterTime']),
</replace>

<edit file>
$sourcedir/RemoveTopic.php
</edit file>

<search for>
// Removes the passed ID_TOPICs. (permissions are NOT checked here!)
</search for>

<add before>
// recycle bin
function RemoveOldTopics3($is_periodical = false)
{
	global $db_prefix, $modSettings, $txt;
	
	if ($is_periodical == true) {	// daily purge
		$recdays = $modSettings['recycle_amount'];
	}
	else
	{								// maintenance purge
		isAllowedTo('admin_forum');
		checkSession('post', 'maintain');
		if ((int) $_POST['recdays'] < 1)
			redirectexit('action=maintain');
		$recdays = (int) $_POST['recdays'];		
	}                                      
	
	// All we're gonna do here is grab the ID_TOPICs and send them to removeTopics().
	$request = db_query("
		SELECT ID_TOPIC
		FROM {$db_prefix}topics
		WHERE recycledTime < " . (time() - 3600 * 24 * $recdays) . "
			AND ID_BOARD = $modSettings[recycle_board]" , __FILE__, __LINE__);
	$topics = array();
	while ($row = mysql_fetch_assoc($request))
		$topics[] = $row['ID_TOPIC'];
	mysql_free_result($request);

	removeTopics($topics, false, true);

	// Log an action into the moderation log.
	logAction($txt['modlog_ac_recycled'], array($txt['modlog_ac_recycle_count'] => count($topics), $txt['modlog_ac_recycle_age'] => $recdays));

	if ($is_periodical == false)
		redirectexit('action=maintain;done');
	
	updateSettings(array('recycled_date' => date('d', time())));
		
}

</add before>

<search for>
					isSticky = 0
</search for>

<replace>
					isSticky = 0,
					recycledTime = " . (time()- 3600 * 24) . "
</replace>

<search for>
			INSERT INTO {$db_prefix}topics
				(ID_BOARD, ID_MEMBER_STARTED, ID_MEMBER_UPDATED, ID_FIRST_MSG, ID_LAST_MSG)
			VALUES ($modSettings[recycle_board], $row[ID_MEMBER], $row[ID_MEMBER], $message, $message)", __FILE__, __LINE__);
</search for>

<replace>
			INSERT INTO {$db_prefix}topics
				(ID_BOARD, ID_MEMBER_STARTED, ID_MEMBER_UPDATED, ID_FIRST_MSG, ID_LAST_MSG, recycledTime)
			VALUES ($modSettings[recycle_board], $row[ID_MEMBER], $row[ID_MEMBER], $message, $message, " . (time()- 3600 * 24) .")", __FILE__, __LINE__);
</replace>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
?>
</search for>

<add before>
// Auto Recycle Bin purge
function autoPurge()
{
	global $modSettings, $sourcedir, $db_prefix;

	// Does recycling conditions meet?
	if(empty($modSettings['recycle_enable']) || $modSettings['recycle_board'] < 1 || empty($modSettings['recycle_auto']) || $modSettings['recycle_amount'] < 1)
		return;

	$current_date = date('d', time());					// parse current day.
	if ($modSettings['recycled_date'] == $current_date)	// return if recycle bin already purged today.
		return;
	$modSettings['recycled_date'] = $current_date; 		// update variable will be used in functions
														// and reflect it into database
	db_query("
		UPDATE {$db_prefix}settings
		SET value = $current_date
		WHERE variable = 'recycled_date'
			AND value <> $current_date 
	" , __FILE__, __LINE__);
	if (db_affected_rows() <= 0)						// check if race condition happened?
		return;
		
	require_once($sourcedir . '/RemoveTopic.php');		// now we can call the function
	removeoldtopics3(true);
}

</add before>

<edit file>
$languagedir/Help.english.php
</edit file>

<search for>
?>
</search for>

<add before>
// Recycle Bin
$helptxt['recycle_auto'] = 'If this checked, posts are older than amount will be purged. But please keep in mind, purged posts cannot be restored because of they will permanently removed from database. The purge period is every 1 day.';
$helptxt['recycle_amount'] = 'Amount of day determines how older posts will be purged. Its calculating according to when message recycled, not when message posted.';
$helptxt['recycle_admin'] = 'You can purge unnecessary recyled posts from here. Amount of day calculating according to when message recycled, not when message posted. But please keep in mind, purged posts cannot be restored because of they will permanently removed from database.';

</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
// Recycle Bin 
$txt['recycle_admin_title'] = 'Purge Recycle Bin';
$txt['recycle_admin_amount_1'] = 'Purge posts in recycle bin older than';
$txt['recycle_admin_amount_2'] = 'days.';
$txt['recycle_admin_button'] = 'Purge now';
$txt['recycle_admin_confirm'] = 'Are you really sure you want to purge old posts now?\\n\\nPurged posts will be permanently deleted from database.';
$txt['recycle_recycled_time'] = 'Recycled time';
$txt['recycle_auto'] = 'Auto clean recycle bin';
$txt['recycle_amount'] = 'Posts will be purged older than (days)';
$txt['modlog_ac_recycled'] = 'Recycle Bin purged';
$txt['modlog_ac_recycle_count'] = 'count';
$txt['modlog_ac_recycle_age'] = 'age';

</add before>

<edit file>
$themedir/Admin.template.php
</edit file>

<search for>
	// Pruning any older posts.
</search for>

<add before>
	//Purge recycle bin.
	if (!empty($modSettings['recycle_enable']) && !empty($modSettings['recycle_board']))
	echo '
			<tr class="titlebg">
				<td><a href="', $scripturl, '?action=helpadmin;help=recycle_admin" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" align="top" /></a> ', $txt['maintain_title'], ' - ', $txt['recycle_admin_title'], '</td>
			</tr>
			<tr>
				<td class="windowbg2">
				<form action="', $scripturl, '?action=removeoldtopics3" method="post" accept-charset="', $context['character_set'], '" name="recForm" id="recForm">
					', $txt['recycle_admin_amount_1'] ,' <input type="text" name="recdays" value="', !empty($modSettings['recycle_amount']) ? $modSettings['recycle_amount'] : 7 ,'" size="2" /> ', $txt['recycle_admin_amount_2'] ,'
			        <div align="right" style="margin: 1ex;"><input type="submit" value="', $txt['recycle_admin_button'], '" onclick="return confirm(\'', $txt['recycle_admin_confirm'], '\');" /></div>
					<input type="hidden" name="sc" value="', $context['session_id'], '" />
				</form>
				</td>
			</tr>';

</add before>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
					<input type="checkbox" name="recycle_enable" id="recycle_enable_check"', empty($modSettings['recycle_enable']) ? '' : ' checked="checked"', ' class="check" onclick="document.getElementById(\'recycle_board_select\').disabled = !this.checked;" />
</search for>

<replace>
					<input type="checkbox" name="recycle_enable" id="recycle_enable_check"', empty($modSettings['recycle_enable']) ? '' : ' checked="checked"', ' class="check" onclick="document.getElementById(\'recycle_board_select\').disabled = !this.checked; document.getElementById(\'recycle_auto_check\').disabled = !this.checked; document.getElementById(\'recycle_amount_text\').disabled = !(document.getElementById(\'recycle_auto_check\').checked && !document.getElementById(\'recycle_auto_check\').disabled);" />
</replace>

<search for>
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						document.getElementById("recycle_board_select").disabled = !document.getElementById("recycle_enable_check").checked;
</search for>

<replace>
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[                                               
						document.getElementById("recycle_board_select").disabled = !document.getElementById("recycle_enable_check").checked;
					// ]]></script>
				</td>
			</tr><tr class="windowbg2">
				<th width="50%" align="right"><label for="recycle_auto_check">', $txt['recycle_auto'], '</label> <span style="font-weight: normal;">(<a href="', $scripturl, '?action=helpadmin;help=recycle_auto" onclick="return reqWin(this.href);">?</a>)</span>:</th>
				<td>
					<input type="checkbox" name="recycle_auto" id="recycle_auto_check"', empty($modSettings['recycle_auto']) ? '' : ' checked="checked"', ' class="check" onclick="document.getElementById(\'recycle_amount_text\').disabled = !this.checked;" />
				</td>
			</tr><tr class="windowbg2">
				<th width="50%" align="right"><label for="recycle_amount_text">', $txt['recycle_amount'], '</label> <span style="font-weight: normal;">(<a href="', $scripturl, '?action=helpadmin;help=recycle_amount" onclick="return reqWin(this.href);">?</a>)</span>:</th>
				<td>
					<input type="hidden" name="recycle_amount" value="', empty($modSettings['recycle_amount']) ? '0' : $modSettings['recycle_amount'], '" />
					<input type="text" name="recycle_amount" id="recycle_amount_text" value="', $modSettings['recycle_amount'], '" size="3" />
					<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
						document.getElementById("recycle_auto_check").disabled = !document.getElementById("recycle_enable_check").checked;
						document.getElementById("recycle_amount_text").disabled = !document.getElementById("recycle_auto_check").checked;
</replace>

<edit file>
$themedir/MessageIndex.template.php
</edit file>

<search for>
						<td class="catbg3" width="22%"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>';
</search for>

<replace>
						<td class="catbg3" width="22%"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=last_post', $context['sort_by'] == 'last_post' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', ((!empty($modSettings['recycle_enable']) && !empty($modSettings['recycle_board'])) && ($modSettings['recycle_board'] == $context['current_board'])) ? $txt['recycle_recycled_time'] : $txt[111], $context['sort_by'] == 'last_post' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>';
</replace>

<edit file>
$boarddir/index.php
</edit file>

<search for>
	loadPermissions();
</search for>

<add after>
	
	// Auto Recycle Bin purge
	autoPurge();
</add after>

<search for>
		'removeoldtopics2' => array('RemoveTopic.php', 'RemoveOldTopics2'),
</search for>

<add after>
		'removeoldtopics3' => array('RemoveTopic.php', 'RemoveOldTopics3'),
</add after>
